# network design
param n >= 0, integer;
param k >= 1, integer;
set V := 1..n;
set K := 1..k;
param c >= 0;
param m >= 0, integer;
param d{V,V} >= 0 default 0;

var x{V,K} binary;
var w{V,V,K,K} >= 0, <= 1;      

minimize cost :  sum{h in K, l in K, i in V, j in V : 
                      h != l and i < j and d[i,j] > 0} c*d[i,j]*w[i,j,h,l];
subject to assignment {i in V} : sum{h in K} x[i,h] = 1;
subject to cardinality {h in K} : sum{i in V} x[i,h] >= m;
subject to linearization {h in K, l in K, i in V, j in V : 
                            h != l and i < j and d[i,j] > 0} :
                            w[i,j,h,l] >= x[i,h] + x[j,l] - 1;
